//
//  ViewController.swift
//  test_push
//
//  Created by Hans Knöchel on 21.02.18.
//  Copyright © 2018 Hans Knöchel. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

  var pushRequestInitiated = false

  @IBAction func checkPush(_ sender: Any) {
    let settings = UIUserNotificationSettings(types: [.sound, .alert, .badge], categories: nil)
    UIApplication.shared.registerUserNotificationSettings(settings)
  
    UIApplication.shared.registerForRemoteNotifications()
    
    pushRequestInitiated = true
  }

  override func viewDidLoad() {
    super.viewDidLoad()
  
    let notificationCenter = NotificationCenter.default
    notificationCenter.addObserver(self, selector: #selector(appMovedToBackground), name: Notification.Name.UIApplicationWillResignActive, object: nil)
    notificationCenter.addObserver(self, selector: #selector(appMovedToForeground), name: Notification.Name.UIApplicationDidBecomeActive, object: nil)
  }

  @objc func appMovedToBackground() {
    if pushRequestInitiated {
      print("App moved to background, probably showing auth dialog right now!")
    }
  }

  @objc func appMovedToForeground() {
    if pushRequestInitiated {
      pushRequestInitiated = false
      print("App moved to foreground again, checking if push declined silently!")

      if UIApplication.shared.isRegisteredForRemoteNotifications {
        print("Push granted!")
      } else {
        print("Push not granted!")
      }
    }
  }
}
